<?php
/**
 * @param array $pargs
 * @return string
 */
function dzsap_view_generateCssPlayerCustomColors($pargs = array()) {


  $margs = array(
    'colorhighlight' => '',
    'skin_ap' => '',
    'selector' => '', // -- used for playlists

    'config' => array(),
    'configId' => '',
    'call_from' => '',
  );

  $margs = array_merge($margs, $pargs);


  $colorUi = '';
  $colorUiAlternate = '';
  $colorHighlight = '';
  $colorText = '';
  $colorWaveColorBg = '';
  $colorWaveColorProg = '';

  if (isset($margs['config']['color_ui'])) {
    $colorUi = DZSZoomSoundsHelper::sanitizeToHexNonHash($margs['config']['color_ui']);
  }
  if (isset($margs['config']['color_ui_alternate'])) {
    $colorUiAlternate = DZSZoomSoundsHelper::sanitizeToHexNonHash($margs['config']['color_ui_alternate']);
  }
  if (isset($margs['config']['colorhighlight'])) {
    $colorHighlight = DZSZoomSoundsHelper::sanitizeToHexNonHash($margs['config']['colorhighlight']);
  }
  if (isset($margs['config']['color_text'])) {
    $colorText = DZSZoomSoundsHelper::sanitizeToHexNonHash($margs['config']['color_text']);
  }
  if (isset($margs['config']['design_wave_color_bg'])) {
    $colorWaveColorBg = DZSZoomSoundsHelper::sanitizeToHexNonHash($margs['config']['design_wave_color_bg']);
  }
  if (isset($margs['config']['design_wave_color_progress'])) {
    $colorWaveColorProg = DZSZoomSoundsHelper::sanitizeToHexNonHash($margs['config']['design_wave_color_progress']);
  }

  $fout = '';

  global $dzsap;


  array_push($dzsap->extraCssConsumedConfigurations, $margs['configId']);


  if (!$colorHighlight && !$colorUi && !$colorText && $colorUiAlternate) {
    return '';
  }


  $selectorApConfig = '.audioplayer' . DZSAP_VIEW_APCONFIG_PREFIX . DZSZoomSoundsHelper::string_sanitizeToCssClass($margs['configId']);

  $colorsFromColorsCss = '';




//  $colorsFromColorsCss .= 'body .audioplayer:not(.scrubbar-type-wave) .ap-controls .scrubbar .scrub-bg{background-color:#828080} body .audioplayer.skin-wave .meta-artist .the-name,body .audioplayer.skin-wave .meta-artist .the-name>a,      body .audioplayer.skin-wave.button-aspect-noir.button-aspect-noir--filled .playbtn .the-icon-bg,body .audioplayer.skin-wave.button-aspect-noir.button-aspect-noir--filled .pausebtn .the-icon-bg,body .audioplayer.skin-wave.button-aspect-noir.button-aspect-noir--filled i.svg-icon{color:#ddd} body .audioplayer.skin-wave.button-aspect-noir.button-aspect-noir--filled .svg-icon path{fill:#ddd} body .audioplayer.skin-aria .ap-controls .ap-controls-left .con-playpause{background-color:#996b99}body .audioplayer.skin-aria .ap-controls .ap-controls-left .con-playpause path{fill:#ddd}body .audioplayer.skin-aria .ap-controls .ap-controls-right{background-color:#e7e5e5}body .dzsap-color_inverse_ui_fill:not(.a) path{fill:#ddd}body .audioplayer.skin-wave .svg-icon path{fill:#ddd} ';

  if($colorUi){
    $colorsFromColorsCss.=' body .audioplayer .player-but .svg-icon path{fill:--COLOR_UI_PLACEHOLDER--}        body .controls-volume.controls-volume-vertical .volume-holder{background-color:--COLOR_UI_PLACEHOLDER--;}    body .audioplayer.skin-wave .player-but .the-icon-bg{background-color:--COLOR_UI_PLACEHOLDER--;}    body .audioplayer.skin-wave .volume_static:before{background-color:--COLOR_UI_PLACEHOLDER--;} body .audioplayer.skin-wave .meta-artist .the-name object>a{color:--COLOR_UI_PLACEHOLDER--;}  body .audioplayer.skin-wave .volumeicon:before{border-right-color:--COLOR_UI_PLACEHOLDER--}  body .audioplayer.skin-wave .volumeicon{background:--COLOR_UI_PLACEHOLDER--} body .audioplayer.skin-wave.button-aspect-noir i.svg-icon{color:--COLOR_UI_PLACEHOLDER--}   body .audioplayer.skin-wave.button-aspect-noir .con-playpause .the-icon-bg{border-color:--COLOR_UI_PLACEHOLDER--;}   body .audioplayer.skin-wave.button-aspect-noir .player-but .the-icon-bg{background-color:transparent;border-color:--COLOR_UI_PLACEHOLDER--;}   body .audioplayer.skin-wave.button-aspect-noir.button-aspect-noir--filled .player-but .the-icon-bg{background-color:--COLOR_UI_PLACEHOLDER--;}  body .audioplayer.skin-wave.button-aspect-noir.button-aspect-noir--stroked i.svg-icon{color:--COLOR_UI_PLACEHOLDER--}      body .audioplayer.skin-wave.button-aspect-noir.button-aspect-noir--stroked .svg-icon path{stroke:--COLOR_UI_PLACEHOLDER--}    body .audioplayer.skin-wave.button-aspect-noir .svg-icon path{fill:--COLOR_UI_PLACEHOLDER--; } ';

    // -- skin-silver
    $colorsFromColorsCss.=' body .audioplayer.skin-silver .ap-controls .ap-controls-right .controls-volume .volumeicon::before{ border-right-color:--COLOR_UI_PLACEHOLDER--; } body .audioplayer.skin-silver .ap-controls .ap-controls-right .controls-volume .volumeicon {  background-color:--COLOR_UI_PLACEHOLDER--;  } ';
    // -- skin-default
    $colorsFromColorsCss.=' body .audioplayer.skin-default .ap-controls .ap-controls-right .controls-volume .volumeicon::before{ border-right-color:--COLOR_UI_PLACEHOLDER--; } body .audioplayer.skin-default .ap-controls .ap-controls-right .controls-volume .volumeicon {  background-color:--COLOR_UI_PLACEHOLDER--;  } ';
  }
  if($colorText){
    $colorsFromColorsCss.=' 
    .audioplayer.skin-wave .meta-artist .the-name, .audioplayer.skin-wave .meta-artist .the-name>a, .audioplayer.skin-wave .meta-artist .the-name object>a{
    color:--COLOR_UI_TEXT_PLACEHOLDER--;  } 
    ';

    // -- skin-silver
    $colorsFromColorsCss.='body .audioplayer.skin-silver .ap-controls .meta-artist-con{color:--COLOR_UI_TEXT_PLACEHOLDER--}   body .audioplayer.skin-silver .ap-controls .curr-time,  body .audioplayer.skin-silver .ap-controls .ap-controls-right .total-time{color:--COLOR_UI_TEXT_PLACEHOLDER--} ';
    // -- skin-pro
    $colorsFromColorsCss.=' body .audioplayer.skin-pro:not(.a) .ap-controls .scrubbar .scrub-bg{ background-color: --COLOR_UI_TEXT_PLACEHOLDER--; }';


    // -- skin-aria
    $colorsFromColorsCss.='body .audioplayer.skin-aria .ap-controls .ap-controls-left{background-color:--COLOR_UI_TEXT_PLACEHOLDER--}  body .audioplayer.skin-aria .ap-controls .ap-controls-right .meta-artist-con{color:--COLOR_UI_TEXT_PLACEHOLDER--}';
  }

  if($colorHighlight){

    $colorsFromColorsCss.='body .audioplayer .volume_active{background-color:--COLOR_HIGHLIGHT_PLACEHOLDER--}   body .btn-zoomsounds.btn-like:hover .the-icon>svg path,body .btn-zoomsounds.btn-like.active .the-icon>svg path{fill:--COLOR_HIGHLIGHT_PLACEHOLDER--}  body .audioplayer.skin-wave .volume_active{background-color:--COLOR_HIGHLIGHT_PLACEHOLDER--}  body .audioplayer.skin-wave .meta-artist .the-artist{color:--COLOR_HIGHLIGHT_PLACEHOLDER--}    ';
    // -- skin-silver
    $colorsFromColorsCss.=' body .audioplayer.skin-silver a{color:--COLOR_HIGHLIGHT_PLACEHOLDER--}    body .audioplayer.skin-silver{line-height:1}  body .dzsap-color_inverse_ui_text{color:--COLOR_HIGHLIGHT_PLACEHOLDER--}';

  }

  if ($colorUiAlternate) {
    $colorsFromColorsCss .= 'body .audioplayer .player-but .svg-icon path{fill:--COLOR_UI_ALT_PLACEHOLDER--;}';
    $colorsFromColorsCss .= 'body .audioplayer.skin-wave.button-aspect-noir.button-aspect-noir--filled .svg-icon path{fill:--COLOR_UI_ALT_PLACEHOLDER--;} body .audioplayer.skin-wave.button-aspect-noir.button-aspect-noir--filled i.svg-icon{ color: --COLOR_UI_ALT_PLACEHOLDER--; }';
  }



  if($colorWaveColorBg){

    // -- skin-pro
    $colorsFromColorsCss.=' body .audioplayer.skin-pro:not(.a) .ap-controls .scrubbar .scrub-bg{ background-color: --COLOR_SCRUB_BG_PLACEHOLDER--; }';


  }
  if($colorWaveColorProg){
    $colorsFromColorsCss.='body .audioplayer.scrubbar-type-bar .scrubbar .scrub-prog{ background-color:--COLOR_SCRUB_PROG_PLACEHOLDER--; }';
  }


  $colorsFromColorsCss = str_replace('body .audioplayer', $selectorApConfig, $colorsFromColorsCss);

  $colorsFromColorsCss = str_replace('--COLOR_UI_PLACEHOLDER--', '#' . $colorUi, $colorsFromColorsCss);
  $colorsFromColorsCss = str_replace('--COLOR_UI_TEXT_PLACEHOLDER--', '#' . $colorText, $colorsFromColorsCss);
  $colorsFromColorsCss = str_replace('--COLOR_HIGHLIGHT_PLACEHOLDER--', '#' . $colorHighlight, $colorsFromColorsCss);
  $colorsFromColorsCss = str_replace('--COLOR_UI_ALT_PLACEHOLDER--', '#' . $colorUiAlternate, $colorsFromColorsCss);
  $colorsFromColorsCss = str_replace('--COLOR_SCRUB_BG_PLACEHOLDER--', '#' . $colorWaveColorBg, $colorsFromColorsCss);
  $colorsFromColorsCss = str_replace('--COLOR_SCRUB_PROG_PLACEHOLDER--', '#' . $colorWaveColorProg, $colorsFromColorsCss);


  $fout .= $colorsFromColorsCss;


  return $fout;
}